import { useMemo, useState } from "react"
import React from "react"

const log = console.log
let cache: Array<any> = []
const clear = () => cache = []

const react18 = parseFloat(React.version) > 17

export default <T>(factory: () => T): T => {
    if (react18)
        return useMemo(factory, [])

    const [result] = useState<T>(() => {
        if (log === console.log) {
            queueMicrotask(clear)
            const result = factory()
            cache.push(result)
            return result
        }
        return cache.shift()
    })

    return result
}